// Nouveau projet Gallilee arduino + L298N pour les 4 moteurs couplés par coté
// avec chute Statique et dynamique + LCD avec affichage
#include "Wire.h"
#include "LiquidCrystal_I2C.h"
LiquidCrystal_I2C LCD(0x27, 20, 4); // définit le type d'écran lcd 20 x 4 ,(4 fils : masse fil noir et +5V gris vers breadborad +communication gris clair SDA +violet pale SCL protocole I2C ) 4

// Broches pour les moteurs
#define PIN_ENA 10 // état haut  : moteur tourne du coté A 
#define PIN_IN1 9  // état haut : marche avant avec IN2 etat bas
//PIN_IN2 et PIN_IN3    Ici IN2 et IN3 directement à la masse car les moteurs ne vont qu'en avant
#define PIN_IN4 6  // état haut : marche avant coté B si IN3 bas 
#define PIN_ENB 5  // état haut : moteur tourne du coté B 

#define PIN_Chronos 3 // Photodiode permet d'arreter le chrono 
#define PIN_LASER 2   // éclairage de la photodiode 
// Broche pour l'aimant
#define PIN_AIMANT 11 //

// Broches pour les lumières
#define FEUX_ROUGES 12 // en 2 sur multivibrateur
#define FEUX_VERTS 13  // en 14 sur multivibrateur
#define PIN_LedBleu 4  // R=220 ohms ON s'il faut appuyer, OFF si l'action a été effectuée (fil brun)

// Broches pour les ultrasons
#define EMISSION 7                            // partie pour la mesure de la distance parcourue pencant la chute.
#define ECHO 8                                //
#define SONIC_TIMEOUT (MAX_DISTANCE * 60)     // calculate timeout
#define MAX_DISTANCE 300                      // cm
float deltat, distance, distance0, distance1; // définition des variables distances
int celerite = 342;                           // vitesses du son dans l air

const int bouton = A1;           // PIN A1 tension aux bornes des 100k pour passer d'une phase à l'autre (PULLUP)
const int Chronos = PIN_Chronos; // 
int etatPhotodiode;                // PhotoPhotodiode arrête le chrono dans la chute
int etat;
int etatChrono = 0;
int phase = 0;
int verifDistance = 0;
unsigned long topDepart = 0;
unsigned long topFin = 0;
unsigned long topChute = 0;
unsigned long Time = 0;


unsigned long timedebut = 0; // 3 lignes pour le calcul durée de la chute statique
unsigned long timefin = 0;
unsigned long time;
unsigned long timedebut2 = 0; // 3 lignes pour le calcul durée de la chute dynamique
unsigned long timefin2 = 0;
unsigned long time2;
unsigned long debut = 0;    // début de l'expérience en marche
unsigned long duree = 3500; // durée de l'expérience 3.5 s
unsigned long Time2 = 0;    // début de la phase en mouvement
unsigned long dateCourante = 0;

int vitesseG = 240; //à 200 parcours 2 m en 3s  chute de 35 cm en 0.267s soit 12 à 18 cm par rapport au sol suivant l'état des accus

int vitesseD = 170; //<à 200  pour compenser une trajectoire courbe (défaut de paralllelisme)
// ****************put your setup code here, to run once:*****************

void setup()
{

  Serial.begin(9600);
  pinMode(FEUX_ROUGES, OUTPUT);
  pinMode(FEUX_VERTS, OUTPUT);
  digitalWrite(FEUX_ROUGES, HIGH);

  LCD.init(); // initialisation de l'afficheur
  LCD.backlight();
  LCD.setCursor(0, 0); // affiche dès le 1er caractère, ligne 1
  LCD.print("*******************");
  LCD.setCursor(0, 1); // affiche dès le 1er caractère, ligne 2
  LCD.print("* REFERENTIELS    *");
  LCD.setCursor(0, 2); // affiche dès le 1er caractère, ligne 3
  LCD.print("*      GALILEENS  *");
  LCD.setCursor(0, 3); // affiche dès le 1er caractère, ligne 4
  LCD.print("* Chute d'un objet*");
  delay(4000);                      // affiche pendant 4s;
  LCD.setCursor(0, 0);              // affiche dès le 1er caractère
  LCD.print("* Partie STATIQUE *"); // nouvel affichage 1ere partie
  LCD.setCursor(1, 1);              // affiche dès le 2eme caractère, ligne 2
  LCD.print("  Moteurs OFF    ");
  LCD.setCursor(1, 2);
  LCD.print("                 "); // efface la ligne 3 du précédent écran
  delay(3000);
  pinMode(bouton, INPUT);      // définit l'action à mener état 0,1,2,3
  pinMode(PIN_Chronos, INPUT); // pour le chrono
  pinMode(PIN_ENA, OUTPUT);    // moteur
  pinMode(PIN_IN1, OUTPUT);    // moteur
  pinMode(PIN_IN4, OUTPUT);    // moteur
  pinMode(PIN_ENB, OUTPUT);    // moteur
  
  pinMode(PIN_AIMANT, OUTPUT); // Aimant
  pinMode(PIN_LASER, OUTPUT);

  pinMode(PIN_LedBleu, OUTPUT); // leds
  pinMode(EMISSION, OUTPUT);    // Ultrason pour mesure de distance
  pinMode(ECHO, INPUT);         // Ultrason

  digitalWrite(PIN_AIMANT, HIGH); // aimant actif
  digitalWrite(PIN_LASER, LOW);

  phase = 0; // 0 partie statique, 2 pour essai 2ème partie dynamique
}
void loop()

{

  // 1ere partie étude de la chute à l'arrêt et leds rouges ON

  if (phase == 0)
  {

    
    LCD.setCursor(1, 2); // affiche dès le 2ème caractère
    LCD.print(" Placer l'objet  ");
    delay(3000);
    digitalWrite(FEUX_ROUGES, HIGH);
     digitalWrite(PIN_LASER, HIGH);   

   while (digitalRead(PIN_Chronos) == LOW) // etatPhotodiode = digitalRead(PIN_Chronos);
//si la photodiode est éclairée, il faut la masquer
    {
      LCD.setCursor(1, 3); // affichage 4eme ligne décallée au 2éme caractère
      LCD.print("Masquer PhotoDiode");
    }
    //LCD.setCursor(17, 2); // debugage  affiche la phase dès le 17ème caractère ligne 3
    //LCD.print(phase);
    delay(4000);
  }

  while (phase == 0)
  {
    digitalWrite(FEUX_ROUGES, LOW);
    digitalWrite(FEUX_VERTS, HIGH); // début de l'expérience
    LCD.setCursor(0, 3); // affiche dès le 1er caractère ligne 4
    LCD.print("-Appuyer Bouton _-_");
   
    digitalWrite(PIN_LedBleu, HIGH); //     pour demander d'appuyer sur le bouton
    phase = NewPhase(phase);
    //LCD.setCursor(17, 2); // debugage  affiche dès le 17ème caractère si la phase a bien changé
   // LCD.print(phase);     // permet de voir si l'action sur le bouton est validée
    //LCD.print("-");
    delay(200); // quelle influence sur la lenteur du bouton?
  }

  if (phase == 1 && etatChrono == 0) // chute statique
  {
    digitalWrite(PIN_AIMANT, LOW); // debut chute
    etatChrono = 1;                // pour éviter que timedebut soit réécrit dans la boucle
    timedebut = micros();          // enregistre l'heure de la chute
    //LCD.setCursor(14, 2);          // debugage  affiche dès le 14ème caractère
    //LCD.print(timedebut);
  }
  if (phase == 1 && etatChrono == 1)
  {
    etatPhotodiode = digitalRead(PIN_Chronos); // on attend l'arrivée de l'objet
    if (etatPhotodiode == LOW)                 //-------------------fin de la chute
    {
      timefin = micros();        // enregistre l'heure de l'arrivée de l'objet
     
      digitalWrite(FEUX_ROUGES, LOW); 
      digitalWrite(PIN_LASER, LOW); // laser inutile donc OFF

      time = timefin - timedebut; // durée de la chute
      etatChrono = 2;             // pour que le programme passe à la suite
      LCD.clear();                // efface tout
      LCD.setCursor(0, 0);
      LCD.print("Duree de la chute :");

      // on affiche le temps de chute

      time = time / 1000;
      LCD.setCursor(1, 2);
      LCD.print(time);
      LCD.print(" ms **");
      delay(4000); // affichage pendant 4 s.
      digitalWrite(FEUX_VERTS, LOW);
      digitalWrite(FEUX_ROUGES, HIGH);
      LCD.setCursor(0, 3);
      LCD.print("-Appuyer Bouton _-_"); // pour passer à la suite de l'expérience en mouvement
      // delay(2000);
      etatChrono = 3; // fin mesure du temps 
    }
  }
  if (phase == 1 && etatChrono == 3)
  {
    digitalWrite(PIN_LedBleu, HIGH);
   
    phase = NewPhase(phase);
  }
  while (phase == 2) // etude en mouvement mise en place sous l'aimant
  {
    LCD.clear();
    LCD.setCursor(0, 0); // affiche dès le 1er caractère
    LCD.print("* Partie DYNAMIQUE *");
    digitalWrite(PIN_AIMANT, HIGH); // aimant actif

    digitalWrite(PIN_LASER, HIGH);
   

    while (digitalRead(PIN_Chronos) == LOW)

    {
      LCD.setCursor(1, 2); // affichage 2eme ligne décalée au 2eme caractère
      LCD.print("Masquer PhotoDiode");
    }

    LCD.setCursor(0, 0); // affiche dès le 1er caractère ligne2
    LCD.print("Placer le mobile a:");
    LCD.setCursor(0, 1);
    LCD.print("2.2m d'1 OBSTACLE- ");

    while (verifDistance == 0) // boucle dans laquelle on vérifie que la position de départ est la bonne
    {
      distance = getSonar();
      LCD.setCursor(0, 2);
      LCD.print("distance est: ");
      LCD.setCursor(16, 2);
      LCD.print(distance,0);
      delay(1000);
      if (distance <= 200)
      {
       

        LCD.setCursor(0, 3);
        LCD.print("reculer le mobile   ");
      }
      else if (distance >= 250)
      {
        LCD.setCursor(0, 3);
        LCD.print("avancer le mobile   ");
      }
      else
      {
        LCD.setCursor(0, 2);
        LCD.print("                   ");
        LCD.setCursor(0, 3);
        LCD.print("                   ");
        verifDistance = 1; //on sort de la boucle
        delay(1000);
      }
    }
    LCD.setCursor(0, 0);
    LCD.print("* Partie DYNAMIQUE *");
    LCD.setCursor(0, 1); // affiche dès le 1er caractère
    LCD.print("Placer l'objet*     ");
    LCD.setCursor(0, 3);
    LCD.print("-Et Appuyer Bouton -");
    digitalWrite(PIN_LedBleu, HIGH);

    digitalWrite(FEUX_ROUGES, LOW);
    delay(700);
    digitalWrite(FEUX_VERTS, HIGH); // en mouvement
    phase = NewPhase(phase);
  }
  if (phase == 3) // préparation du timing de mouvement et de chute
  {
    distance0 = 0;
    distance1 = 0;
    topDepart = millis();
    topFin = topDepart + 3500;
    etatChrono = 0;
    topChute = topDepart + 2500;
    phase = 4;
    LCD.setCursor(18, 3); //**********pour voir si phase est prise en compte
    LCD.print(phase);
  }

  // 2ème partie étude de la chute en mouvement leds rouges oranges ON OFF
  while (phase == 4)
  {
    unsigned long debut = millis();

    Time2 = millis();

    if (Time2 < topFin) // mise en route des moteurs pour 3.5s
    {

      digitalWrite(PIN_IN1, HIGH); // L'entrée IN1 doit être au niveau haut
      // digitalWrite(PIN_IN2, LOW);  L'entrée IN2 doit être au niveau bas réalisé en mettant à la masse par un fil blanc
      digitalWrite(PIN_IN4, HIGH); // L'entrée IN1 doit être au niveau haut
      // digitalWrite(PIN_IN3, LOW); L'entrée IN3 doit être au niveau bas réalisé en mettant à la masse par un fil blanc
      analogWrite(PIN_ENA, vitesseG);
      analogWrite(PIN_ENB, vitesseD);
      if (Time2 > topChute && distance0 == 0)
      {
        digitalWrite(PIN_AIMANT, LOW); // chute de l'objet
        timedebut2 = micros();
        distance0 = getSonar();
      }
      else if (Time2 > topChute && distance1 == 0)
      {
        etatPhotodiode = digitalRead(PIN_Chronos); // on attend l'arrivée de l'objet
        if (etatPhotodiode == LOW)
        {
          timefin2 = micros();         // enregistre l'heure de l'arrivée de l'objet
     
          time2 = timefin2 - timedebut2;
          time2 = time2 / 1000;
          distance1 = getSonar();
          LCD.setCursor(0, 1);
          LCD.print("                    "); // efface ligne 2
          LCD.setCursor(0, 1);
          LCD.print(distance0, 1);
          LCD.setCursor(10, 1);
          LCD.print(distance1, 1);
          LCD.setCursor(0, 2); // place le curseur au début de la 3ème ligne
          LCD.print("distance parcourue  ");
          LCD.setCursor(0, 3);
          LCD.print("                    "); // efface ligne4
          LCD.setCursor(0, 3);
          LCD.print(distance0 - distance1, 1); // affiche distance
          LCD.setCursor(5, 3);
          LCD.print("cm en "); // affiche distance en cm
          LCD.setCursor(12, 3);
          LCD.print(time2);
          LCD.setCursor(16, 3);
          LCD.print(" ms"); // affiche durée de la chute en ms
        }
      }
    }

    else // on sort de la boucle et le moteur s'arrete
    {

      digitalWrite(FEUX_VERTS, LOW);
      analogWrite(PIN_ENA, 0);      // moteurA STOP
      analogWrite(PIN_ENB, 0);      // moteurB STOP
      digitalWrite(PIN_LASER, LOW); // laser inutile donc OFF
      
      phase = 8; // pour sortir du programme
    }
  }
}

// incremente phase de 0 à 1 puis 2 etc. pour les différentes phases de l'expérience

int NewPhase(int phase)
{
  int etat = analogRead(bouton);
  LCD.setCursor(15, 1); // debug
  LCD.print(phase);     // debut
  if (etat <= 300)      // teste si le bouton est appuyé
  {
    digitalWrite(PIN_LedBleu, LOW); //éteindre led bleu pour savoir si le bouton a été pris en compte
    phase = phase + 1;

    LCD.setCursor(17, 1);
    LCD.print(phase);
    delay(1500);
    return phase;
  }
}
// partie mesure de distance
float getSonar() // fonction mesure de la distance
{
  unsigned long pingTime;
  // delayMicroseconds(2); // delai de 2 microseconde:
  digitalWrite(EMISSION, HIGH);
  delayMicroseconds(10); // salve de 10 microsecondes
  digitalWrite(EMISSION, LOW);

  pingTime = pulseIn(ECHO, HIGH, SONIC_TIMEOUT); // Wait HC-SR04 returning to the high level and measure out this waiting time
  if (pingTime != 0)
    distance = (float)pingTime * celerite / 2 / 10000; // calculate the distance according to the time
  else
    distance = MAX_DISTANCE;
  return distance; // return the distance value
  // Calcule la distance programme à partir de pingTime et de la célérité c = 342 ms-1
}


